Package: RCircos
Type: Package
Title: Circos 2D Track Plot
Version: 1.2.2
Date: 2021-12-14
Author: Hongen Zhang 
Maintainer: Hongen Zhang <hzhang.henry@gmail.com>
Description: A simple and flexible way to generate Circos 2D track plot images for genomic data visualization is implemented in this package. The types of plots include: heatmap, histogram, lines, scatterplot, tiles and plot items for further decorations include connector, link (lines and ribbons), and text (gene) label. All functions require only R graphics package that comes with R base installation.  
License: GPL (>= 2)
Depends: R (>= 2.10)
URL: https://github.com/hzhanghenry/RCircos
NeedsCompilation: no
Packaged: 2021-12-19 17:10:42 UTC; hzhang
Repository: CRAN
Date/Publication: 2021-12-19 18:50:02 UTC
Built: R 4.6.0; ; 2026-04-26 23:39:15 UTC; unix

importFrom("grDevices", "col2rgb", "colors", "rgb")
importFrom("graphics", "lines", "par", "plot.new", "plot.window",
             "points", "polygon", "rect", "text")
importFrom("utils", "as.roman")

exportPattern("^[[:alpha:]]+")

    #
    #   This demo draw chromosome ideogram with padding between chromosomes, 
    #   highlights, chromosome names, and link lines. 
    #
    #   Usage:
    #
    #   library(RCircos);
    #   demo("RCircos.Link.Plot.Demo");
    #   ______________________________________________________________________
    #   <RCircos DEMO><RCircos DEMO><RCircos DEMO><RCircos DEMO><RCircos DEMO> 



    #   Load RCircos library
    #   _______________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    library(RCircos);


    #   Load human cytoband data and link data
    #   _______________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    data(RCircos.Link.Data);
    data(UCSC.HG19.Human.CytoBandIdeogram);
    cyto.info <- UCSC.HG19.Human.CytoBandIdeogram;


    #   Setup RCircos core components:
    #   ________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    RCircos.Set.Core.Components(cyto.info, NULL, 10, 0);


    #   Open the graphic device (here a pdf file)
    #   _____________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    out.file <- "RCircos.Link.Plot.Demo.pdf";
    pdf(file=out.file, height=8, width=8);

    RCircos.Set.Plot.Area();


    #   Draw chromosome ideogram
    #   _____________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    message("Draw chromosome ideogram ...\n");

    RCircos.Chromosome.Ideogram.Plot();
    title("RCircos Link Plot Demo");


    #   Link lines. Link data has paired chromosome 
    #   locations only in each row and link lines 
    #   are always drawn inside chromosome ideogram.
    #   ____________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    message("Add link track ...\n");

    link.data <- RCircos.Link.Data;
    link.colors <- rep("blue", nrow(link.data));
    rows <- seq(1, nrow(link.data), by=5);
    link.colors[rows] <- "red";
    link.data["PlotColor"] <- link.colors;

    track.num <- 2;
    RCircos.Link.Plot(link.data, track.num, FALSE);


    #   Close the graphic device and clear memory
    #   ___________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    dev.off();
    message("RCircos Link Plot Demo Done!");

    #
    #   This demo draw chromosome ideogram with padding between 
    #   chromosomes, highlights, chromosome names, and heatmap 
    #   with gene expression data.
    #
    #   Usage:
    #
    #   library(RCircos);
    #   demo("RCircos.Heatmap.Demo");
    #   ______________________________________________________________________
    #   <RCircos DEMO><RCircos DEMO><RCircos DEMO><RCircos DEMO><RCircos DEMO>



    #   Load RCircos library
    #   _________________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    library(RCircos);


    #   Load human cytoband data and gene expression data
    #   _________________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    data(RCircos.Heatmap.Data);
    data(UCSC.HG19.Human.CytoBandIdeogram);
    cyto.info <- UCSC.HG19.Human.CytoBandIdeogram;


    #   Setup RCircos core components:
    #   _________________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    RCircos.Set.Core.Components(cyto.info, NULL, 5, 0);


    #   Open the graphic device (here a pdf file)
    #   _________________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    out.file <- "RCircos.Heatmap.Demo.pdf";
    pdf(file=out.file, height=8, width=8);

    RCircos.Set.Plot.Area();


    #   Draw chromosome ideogram
    #   _________________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    message("Draw chromosome ideogram ...\n");

    RCircos.Chromosome.Ideogram.Plot();
    title("RCircos Heatmap Plot Demo");



    #   Plot five tracks of heatmap
    #   _________________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    total.track <- 5;
    for(a.track in 1:total.track)
    {
        data.col <- a.track + 4;
        RCircos.Heatmap.Plot(RCircos.Heatmap.Data, data.col, a.track, "in");
    }


    #   Close the graphic device
    #   _________________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    dev.off();
    message("RCircos Heatmap demo done!\n");

    #
    #   This demo draw human chromosome ideogram and data tracks for:
    #
    #   1.  Connectors
    #   2.  Gene lables
    #   3.  Heatmap
    #   4.  Scatterplot 
    #   5.  Line plot
    #   6.  Histogram
    #   7.  Tile plot
    #   8.  Link lines
    #
    # ______________________________________________________________________
    # <RCircos DEMO><RCircos DEMO><RCircos DEMO><RCircos DEMO><RCircos DEMO>



    #   Load RCircos package
    #   _________________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    library(RCircos);



    #   Load human cytoband data 
    #   _________________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    data(UCSC.HG19.Human.CytoBandIdeogram);
    hg19.cyto <- UCSC.HG19.Human.CytoBandIdeogram;


    #   Setup RCircos core components:
    #   _________________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    RCircos.Set.Core.Components(cyto.info=hg19.cyto, chr.exclude=NULL, 
                tracks.inside=10, tracks.outside=0);



    #   Open the graphic device (here a pdf file)
    #
    #   png(file="RCircos.Demo.Human.png", height=8, width=8, unit="in", 
    #       type="cairo", res=300);
    #
    #   tiff(file="RCircos.Demo.Human.tif", height=8, width=8, unit="in", 
    #           type="cairo", res=300);
    #   _________________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    message("Open graphic device and start plot ...\n");
    pdf(file="RCircos.Demo.Human.pdf", height=8, width=8);

    RCircos.Set.Plot.Area();
    title("RCircos 2D Track Plot with Human Genome");



    #   Draw chromosome ideogram
    #   _________________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    message("Draw chromosome ideogram ...\n");
    RCircos.Chromosome.Ideogram.Plot();



    #   Connectors in first track and gene names in the second track. 
    #   _________________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    message("Add Gene and connector tracks ...\n");
    data(RCircos.Gene.Label.Data);

    RCircos.Gene.Connector.Plot(genomic.data=RCircos.Gene.Label.Data, 
                track.num=1, side="in");
    RCircos.Gene.Name.Plot(gene.data=RCircos.Gene.Label.Data, name.col=4, 
                track.num=2, side="in");


    #   Heatmap plot.  Since some gene names plotted above are longer 
    #   than one track height, we skip two tracks 
    #   _________________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    message("Add heatmap track ...\n");

    data(RCircos.Heatmap.Data);
    RCircos.Heatmap.Plot(heatmap.data=RCircos.Heatmap.Data, data.col=6, 
                track.num=5, side="in");



    #   Scatterplot. 
    #   Note:   There is no prefix of "chr" in chromosome names 
    #           of RCircos.Scatter.Data 
    #   _________________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    message("Add scatterplot track ...\n");
    data(RCircos.Scatter.Data);
    RCircos.Scatter.Plot(scatter.data=RCircos.Scatter.Data, data.col=5, 
                track.num=6, side="in", by.fold=1);



    #   Line plot. 
    #   Note:   There is no prefix of "chr" in chromosome names 
    #           of RCircos.Line.Data
    #   _________________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    message("Add line plot track ...\n");
    data(RCircos.Line.Data);
    RCircos.Line.Data[,1] <- paste0("chr", RCircos.Line.Data[,1])
    RCircos.Line.Plot(line.data=RCircos.Line.Data, data.col=5, 
                track.num=7, side="in");



    #   Histogram plot
    #   _________________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    message("Add histogram track ...\n");

    data(RCircos.Histogram.Data);
    RCircos.Histogram.Plot(hist.data=RCircos.Histogram.Data, data.col=4, 
                track.num=8, side="in");



    #   Tile plot. Note: tile plot data have chromosome locations and each
    #   data file is for one track
    #   _________________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    message("Add tile track ...\n");

    data(RCircos.Tile.Data);
    RCircos.Tile.Plot(tile.data=RCircos.Tile.Data, track.num=9, side="in");



    #   Link lines. Link data has only paired chromosome locations in
    #   each row and link lines are always drawn inside of chromosome 
    #   ideogram.
    #   _________________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    message("Add link track ...\n");

    data(RCircos.Link.Data);
    RCircos.Link.Plot(link.data=RCircos.Link.Data, track.num=11, 
                by.chromosome=FALSE);



    #   Add ribbon link to the center of plot area (link lines).
    #   _________________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

   message("Add ribbons to link track ...\n");

    data(RCircos.Ribbon.Data);
    RCircos.Ribbon.Plot(ribbon.data=RCircos.Ribbon.Data, track.num=11, 
                by.chromosome=FALSE, twist=FALSE);





    #   Close the graphic device and clear memory
    #   _________________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    dev.off();
    message("R Circos Demo Done ...\n\n");

    #   ______________________________________________________________________
    #   <RCircos DEMO><RCircos DEMO><RCircos DEMO><RCircos DEMO><RCircos DEMO>
    #
    #   This demo draw chromosome ideogram with padding between chromosomes, 
    #   highlights, chromosome names, and histogram. 
    #
    #   Usage:
    #
    #   library(RCircos);
    #   demo("RCircos.Histogram.Demo");
    #   ______________________________________________________________________
    #   <RCircos DEMO><RCircos DEMO><RCircos DEMO><RCircos DEMO><RCircos DEMO>



    #   Load RCircos package and defined parameters
    #   ________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    library(RCircos);


    #   Load human cytoband data and gene expression data
    #   ________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    data(RCircos.Histogram.Data);
    data(UCSC.HG19.Human.CytoBandIdeogram);
    cyto.info <- UCSC.HG19.Human.CytoBandIdeogram;


    #   Setup RCircos core components:
    #   _________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    RCircos.Set.Core.Components(cyto.info, NULL, 10, 0);


    #   Open the graphic device (here a pdf file)
    #   _________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    out.file <- "RCircos.Histogram.Demo.pdf";
    pdf(file=out.file, height=8, width=8);

    RCircos.Set.Plot.Area();


    #   Draw chromosome ideogram
    #   _________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    message("Draw chromosome ideogram ...\n");

    RCircos.Chromosome.Ideogram.Plot();
    title("RCircos Histogram Plot Demo");


    #   Plot histogram Inside of chromosome ideogram
    #   _________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    hist.data <- RCircos.Histogram.Data;
    hist.colors <- rep("blue", nrow(hist.data))
    rows <- which(hist.data$Data>0.4)
    hist.colors[rows] <- "red";
    hist.data["PlotColor"] <- hist.colors;

    data.col <- 4; 
    track.num <- 1;
    RCircos.Histogram.Plot(hist.data, data.col, track.num, "in");


    #   Close the graphic device and clear memory
    #   _________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    dev.off();
    message("RCircos Histogram Demo Done!");

    #
    #   This demo draw ribbon links between chromosomes
    #
    #   Usage:
    #
    #   library(RCircos);
    #   demo("RCircos.Tile.Plot.Demo");
    #
    #   ______________________________________________________________________
    #   <RCircos DEMO><RCircos DEMO><RCircos DEMO><RCircos DEMO><RCircos DEMO>



    #   Load RCircos library
    #   _________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    library(RCircos);


    #   Load human cytoband data and link data
    #   _________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    data(RCircos.Ribbon.Data);
    data(UCSC.HG19.Human.CytoBandIdeogram);
    cyto.info <- UCSC.HG19.Human.CytoBandIdeogram;


    #   Setup RCircos core components:
    #   ________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    RCircos.Set.Core.Components(cyto.info, NULL, 10, 0);


    #   Open the graphic device (here a pdf file)
    #   ________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    pdf(file="RCircos.Ribbon.Plot.Demo.pdf", height=8, width=8);
    RCircos.Set.Plot.Area();


    #   Draw chromosome ideogram
    #   ________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    RCircos.Chromosome.Ideogram.Plot();
    title("RCircos Ribbon Plot Demo");


    #   Link lines. Link data has only paired chromosome 
    #   locations in each row and link lines are always 
    #   drawn inside of chromosome ideogram.
    #   __________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    ribbon.data <- RCircos.Ribbon.Data;
    ribbon.data["PlotColor"] <- c("red", "blue", "green", "cyan");

    track.num <- 11;
    RCircos.Ribbon.Plot(ribbon.data, track.num, FALSE);


    #   Close the graphic device and clear memory
    #   _________________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    dev.off();
    message("RCircos Ribbon Plot Demo Done!");

    #
    #   This demo draw chromosome ideogram with padding between  
    #   chromosomes, highlights, chromosome names, and scatters. 
    #
    #   Usage:
    #
    #   library(RCircos);
    #   demo("RCircos.Scatter.Plot.Demo");
    #   ______________________________________________________________________
    #   <RCircos DEMO><RCircos DEMO><RCircos DEMO><RCircos DEMO><RCircos DEMO>



    #   Load RCircos library
    #   ________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    library(RCircos);


    #   Load human cytoband data and scatterplot data
    #   ________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    data(RCircos.Scatter.Data);
	if(length(grep("chr", RCircos.Scatter.Data$chromosome)) == 0)
		RCircos.Scatter.Data$chromosome <- paste0("chr", 
        RCircos.Scatter.Data$chromosome);
    
    data(UCSC.HG19.Human.CytoBandIdeogram);
    cyto.info <- UCSC.HG19.Human.CytoBandIdeogram;


    #   Setup RCircos core components:
    #   ________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    RCircos.Set.Core.Components(cyto.info, NULL, 10, 0);


    #   Open the graphic device (here a pdf file)
    #   ________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    pdf(file="RCircos.Scatter.Plot.Demo.pdf", height=8, width=8);
    RCircos.Set.Plot.Area();


    #   Draw chromosome ideogram
    #   ________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    RCircos.Chromosome.Ideogram.Plot();
    title("RCircos Scatter Plot Demo");


    #   Scatterplot 
    #   _________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    scatter.data <- RCircos.Scatter.Data;
    scatter.colors <- rep("cyan", nrow(scatter.data));
    scatter.colors[which(scatter.data$seg.mean>=2)] <- "red";
    scatter.colors[which(scatter.data$seg.mean<=-2)] <- "blue";
    scatter.data["PlotColor"] <- scatter.colors;

    data.col <- 5;
    track.num <- 6; 
    RCircos.Scatter.Plot(scatter.data, data.col, track.num, "in", 1);



    #   Close the graphic device
    #   ___________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    dev.off();
    message("RCircos Scatter Plot Demo Done!");

    #
    #   This demo draw chromosome ideogram with padding between  
    #   chromosomes, highlights, chromosome names, and three 
    #   empty tracks inside and outside of chromosome ideogram.
    #
    #   Usage:
    #
    #   library(RCircos);
    #   demo("RCircos.Layout.Demo");
    #   ______________________________________________________________________
    #   <RCircos DEMO><RCircos DEMO><RCircos DEMO><RCircos DEMO><RCircos DEMO>



    #   Load RCircos library
    #   _______________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    library(RCircos);


    #   Load human cytoband data 
    #   _______________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    data(UCSC.HG19.Human.CytoBandIdeogram);
    cyto.info <- UCSC.HG19.Human.CytoBandIdeogram;


    #   Setup RCircos core components:
    #   _______________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    RCircos.Set.Core.Components(cyto.info, NULL, 5, 5);



    #   Open the graphic device (here a pdf file)
    #
    #   png(file="RCircos.Layout.Demo.png", height=8, 
    #      width=8, unit="in", type="cairo", res=300);
    #   ________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    out.file <- "RCircos.Layout.Demo.pdf";
    pdf(file=out.file, height=8, width=8);

    RCircos.Set.Plot.Area();


    #   Draw chromosome ideogram
    #   _________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    message("Draw chromosome ideogram ...\n");

    RCircos.Chromosome.Ideogram.Plot();
    title("R Circos Layout Demo");



    #   Marking plot areas both inside and outside of
    #   chromosome ideogram ( 3 for each)
    #   ********************************************
    total.track <- 3;
    subtrack <- 5;


    #   Outside of chromosome ideogram
    #   _________________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    RCircos.Par <- RCircos.Get.Plot.Parameters();
    one.track <- RCircos.Par$track.height + RCircos.Par$track.padding;

    for(a.track in 1:total.track)
    {   
        in.pos    <- RCircos.Par$track.out.start  + (a.track-1)*one.track;
        out.pos <- in.pos + RCircos.Par$track.height;
        RCircos.Track.Outline(out.pos, in.pos, subtrack);
    }

    #   Inside of chromosome ideogram
    #   _________________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    for(a.track in 1:total.track)
    {
        out.pos <- RCircos.Par$track.in.start  - (a.track-1)*one.track;
        in.pos    <- out.pos - RCircos.Par$track.height;
        RCircos.Track.Outline(out.pos, in.pos, subtrack);
    }


    #   Close the graphic device and clear memory
    #   _________________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    dev.off();
    message("RCircos Layout Demo Done!");

    #   ______________________________________________________________________
    #   <RCircos DEMO><RCircos DEMO><RCircos DEMO><RCircos DEMO><RCircos DEMO>
    #
    #   This demo draws a heatmap with both mouse and rat gene expresion 
    #   data and links between same genes. 
    #
    #   We will put mouse data on right side and rat data on left side.  
    #   Since we are going to draw the image with both mouse and rat  
    #   chromosome ideogram, we deduct total points of each ideogram by 
    #   half. This is done by modify the base.per.unit from 3000 to 
    #   30000. Chromosome padding will be automatically modified if we do 
    #   not give it new value.
    #
    #   Last revised on June 9, 2016
    #
    #   ______________________________________________________________________
    #   <RCircos DEMO><RCircos DEMO><RCircos DEMO><RCircos DEMO><RCircos DEMO>




    #   Load RCircos package and defined parameters. 
    #   __________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    library(RCircos);


    #   Load chromosome cytoband data. We will generate 
    #   a pseudo karyotype by concatenating the second 
    #   ideogram data to the first one.
    #   __________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    message("Read in cytoband data ...\n");

    data(UCSC.Mouse.GRCm38.CytoBandIdeogram);
    data(UCSC.Baylor.3.4.Rat.cytoBandIdeogram);


    #   Load mouse and rat gene expression data
    #   __________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    message("Read in gene expression data ...\n");

    data(RCircos.Mouse.Expr.Data);
    data(RCircos.Rat.Expr.Data);


    #   Generate link data from the two datasets. These
    #   lines are regular R script code.
    #   __________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    mouse.data <- RCircos.Mouse.Expr.Data;
    rat.data <- RCircos.Rat.Expr.Data;

    mouse.gene <- as.character(mouse.data$Gene);
    rat.gene   <- as.character(rat.data$Gene);

    mouse.set <- mouse.data[mouse.gene %in% rat.gene,];
    mouse.set <- mouse.set[order(mouse.set$Expr.Mean),];
    last <- nrow(mouse.set);
    first <- last - 49;
    mouse.set <- mouse.set[first:last,];

    mouse.set.gene <- as.character(mouse.set$Gene);
    rat.set <- rat.data[rat.gene %in% mouse.set.gene,];

    mouse.set <- mouse.set[order(mouse.set$Gene),];
    rat.set <- rat.set[order(rat.set$Gene),];

    link.data <- data.frame(mouse.set[,1:3], rat.set[,1:3]);


    #   Modify the datasets and ideogram so that they have
    #   same chromosome names. Please make sure the items
    #   in the two lists have same order.
    #   __________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    species.list <- c("M", "R");

    cyto.list <- list(UCSC.Mouse.GRCm38.CytoBandIdeogram, 
                    UCSC.Baylor.3.4.Rat.cytoBandIdeogram);
    RCircos.Multiple.Species.Core.Components(cyto.list, 
                    species.list, NULL, 5, 5);

    data.list <- list(RCircos.Mouse.Expr.Data, 
                    RCircos.Rat.Expr.Data);
    expr.data <- RCircos.Multiple.Species.Dataset(data.list, 
                    species.list);

    link.data[,1] <- paste(species.list[1], link.data[,1], sep="");
    link.data[,4] <- paste(species.list[2], link.data[,4], sep="");


    #   Setup RCircos core components then change the
    #   base.per.unit to 30000 for fast drawing
    #   __________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    params <- RCircos.Get.Plot.Parameters();
    params$base.per.unit <- 30000;
    RCircos.Reset.Plot.Parameters(params);


    #   Initialize graphic device (GUI or image file)
    #
    #   tiff(file="RCircos.Demo.Mouse.And.Rat.tif", height=8,
    #       width=9, unit="in", type="cairo", res=300);
    #
    #   png(file="RCircos.Demo.Mouse.And.Rat.png", height=8,
    #       width=9, unit="in", type="cairo", res=300);
    #   __________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    message("Initialize graphic device ...\n");

    pdf(file="RCircos.Demo.Mouse.And.Rat.pdf", height=8, width=8);
    RCircos.Set.Plot.Area();


    #   Plot chromosome ideogram, heatmap, and link lines
    #   __________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    RCircos.Chromosome.Ideogram.Plot();

    data.col <- 5;
    track.num <- 1;
    RCircos.Heatmap.Plot(expr.data, data.col, track.num, "in");

    track.num <- 3;
    RCircos.Link.Plot(link.data, track.num, FALSE);


    #   Add a title and a legend
    #   __________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    title("RCircos Demo: Mouse and Rat Gene Expression");
    legend(0.6, 2, legend=c("Right: GSE42081 Mouse", 
                "Left:  GSE42081 Rat"), cex=0.8);


    #   Add a color key
    #   __________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    RCircos.Plot.Heatmap.Color.Scale(max.value=3, min.value=-3,
        color.type="BlueWhiteRed", scale.location=1, 
        scale.width=2, scale.height=0.2) 



    #   Done. Close the device if plot to image file...
    #   _______________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    dev.off();
    message("R Circos Demo with mouse and Rat data done ...\n\n");

#   RCircos area plot demo
#
#   This demo draw chromosome ideogram with ticks, and use histogram
#   data to make histogram plot and area plots ("mountain", "curtain",
#   and "band"). 
#   ______________________________________________________________________
#   <RCircos Demo><RCircos Demo><RCircos Demo><RCircos Demo><RCircos Demo>


    #   Load RCircos package
    #   _________________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    library(RCircos);


    #   Load chromosome ideogram data and histogram plot data then 
    #   set up RCircos core components
    #   __________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    data("UCSC.HG19.Human.CytoBandIdeogram");
    data("RCircos.Histogram.Data");
    RCircos.Set.Core.Components(UCSC.HG19.Human.CytoBandIdeogram, 
            chr.exclude=NULL, tracks.inside=10, tracks.outside=5);


    #   Open graphic device (here a pdf file)
    #   _________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    pdf("RCircos.Area.Plot.Demo.pdf", height=8, width=8);
    RCircos.Set.Plot.Area();


    #   plot chromosome ideogram and histogram 
    #   _________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    RCircos.Chromosome.Ideogram.Plot(20)
    RCircos.Histogram.Plot(RCircos.Histogram.Data, data.col=4, 
        inside.pos=1.59, outside.pos=1.89);


    #   Area plot (mountain, curtain, and band)
    #   _________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    area.data <- RCircos.Histogram.Data;
    adj.value <- runif(nrow(area.data), 0, 0.4)
    area.data["DataT"] <- 0.5 + adj.value
    area.data["DataB"] <- 0.5 - adj.value

    RCircos.Area.Plot(area.data, data.col=4, plot.type="mountain", 
        inside.pos=1.2, outside.pos=1.5, is.sorted=FALSE);

    RCircos.Area.Plot(area.data, data.col=4, plot.type="curtain", 
        inside.pos=0.9, outside.pos=1.1, is.sorted=FALSE);

    RCircos.Area.Plot(area.data, data.col=c(5,6), plot.type="band", 
        inside.pos=0.4, outside.pos=0.7, is.sorted=FALSE);

    title("RCircos Area Plot Demo");


    #   Close the graphic device
    #   _________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    dev.off();

    #
    #   This demo draw human chromosome ideogram with ticks. Since in most 
    #   cases ticks are not necessary for data presentation, we add ticks  
    #   to existing ideogram instead of plotting an ideogram with ticks.
    #
    #   Set 20 tracks inside of chromosome ideogram to get enough space 
    #   for all chromosomes with ticks in 5MB interval
    #
    #   ______________________________________________________________________
    #   <RCircos DEMO><RCircos DEMO><RCircos DEMO><RCircos DEMO><RCircos DEMO> 


    #   Load RCircos package
    #   ==============================================================

    library(RCircos);


    #   Load human cytoband data 
    #   ==============================================================

    data(UCSC.HG19.Human.CytoBandIdeogram);
    hg19.cyto <- UCSC.HG19.Human.CytoBandIdeogram;


    #   Set 10 tracks in outside of chromosome ideogram to get enough 
    #   space for all chromosomes ticks in 10 MB interval
    #   ==============================================================

    RCircos.Set.Core.Components(cyto.info=hg19.cyto, chr.exclude=NULL, 
            tracks.inside=10, tracks.outside=5);


    #   Open the graphic device (here a png image file)
    #   ==============================================================
    pdf(file="RCircos.Demo.Chromosome.Ticks.pdf", height=8, width=8);
    RCircos.Set.Plot.Area();
    title("RCircos Tick Demo")

    #   Draw chromosome ideogram with ticks in 10 mb interval
    #   ==============================================================
    RCircos.Chromosome.Ideogram.Plot(tick.interval=10);


    #   Close the graphic device and clear memory
    #   ==============================================================
    dev.off();
    message("R Circos Tick Demo Done ...\n\n");

    #   ______________________________________________________________________
    #   <RCircos DEMO><RCircos DEMO><RCircos DEMO><RCircos DEMO><RCircos DEMO>
    #
    #   This demo draw chromosome ideogram with padding between chromosomes, 
    #   highlights, chromosome names, and histogram. 
    #
    #   Usage:
    #
    #   library(RCircos);
    #   demo("RCircos.Polygon.Demo");
    #   ______________________________________________________________________
    #   <RCircos DEMO><RCircos DEMO><RCircos DEMO><RCircos DEMO><RCircos DEMO>



    #   Load RCircos package and defined parameters
    #   ________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    library(RCircos);


    #   Load human cytoband data and gene expression data
    #   ________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    data(RCircos.Polygon.Data);
    data(UCSC.HG19.Human.CytoBandIdeogram);
    cyto.info <- UCSC.HG19.Human.CytoBandIdeogram;


    #   Setup RCircos core components:
    #   _________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    RCircos.Set.Core.Components(cyto.info, NULL, 10, 10);


    #   Open the graphic device (here a pdf file)
    #   _________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    pdf(file="RCircos.Polygon.Demo.pdf", height=8, width=8);
    RCircos.Set.Plot.Area();


    #   Draw chromosome ideogram
    #   _________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    message("Draw chromosome ideogram ...\n");

    RCircos.Chromosome.Ideogram.Plot();
    title("RCircos Polygon Plot Demo");


    #   Plot histogram Inside of chromosome ideogram
    #   _________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    polygon.data <- RCircos.Polygon.Data;
    RCircos.Polygon.Plot(polygon.data, track.num=NULL, data.col=4,
        genomic.columns=3, side="in", inside.pos=1.6, outside.pos=1.8, 
        border.col="black", polygon.col="red", is.sorted=TRUE)

    polygon.data$Data <- polygon.data$Data*-1
    RCircos.Polygon.Plot(polygon.data, track.num=NULL, data.col=4,
        genomic.columns=3, side="in", inside.pos=1.3, outside.pos=1.5, 
        border.col="black", polygon.col="green", is.sorted=TRUE)

    rows <- seq(1, 77, by=2)

    plot.colors <- rep("red", nrow(polygon.data))
    plot.colors[rows] <- "green"
    polygon.data["PlotColor"] <- plot.colors
    polygon.data$Data[rows] <- polygon.data$Data[rows]*-1

    RCircos.Polygon.Plot(polygon.data, track.num=NULL, data.col=4,
        genomic.columns=3, side="in", inside.pos=0.8, outside.pos=1.2, 
        border.col="black", polygon.col=NULL, is.sorted=TRUE)

    title("RCircos Polygon Plot Demo")



    #   Close the graphic device and clear memory
    #   _________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    dev.off();
    message("RCircos Polygon Plot Demo Done!");

    #
    #   This demo draw chromosome ideogram with padding between
    #   chromosomes, highlights, chromosome names, and line plot. 
    #
    #   Usage:
    #
    #   library(RCircos);
    #   demo("RCircos.Line.Plot.Demo");
    #   ______________________________________________________________________
    #   <RCircos Demo><RCircos Demo><RCircos Demo><RCircos Demo><RCircos Demo>



    #   Load RCircos library
    #   ___________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    library(RCircos);


    #   Load human cytoband data and line plot data
    #   ____________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    data(RCircos.Line.Data);
    RCircos.Line.Data$chromosome <- paste0("chr", 
        RCircos.Line.Data$chromosome);

    data(UCSC.HG19.Human.CytoBandIdeogram);
    cyto.info <- UCSC.HG19.Human.CytoBandIdeogram;


    #   Setup RCircos core components:
    #   _____________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    RCircos.Set.Core.Components(cyto.info, NULL, 10, 0);


    #   Open the graphic device (here a pdf file)
    #   _____________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    out.file <- "RCircos.Line.Plot.Demo.pdf";
    pdf(file=out.file, height=8, width=8);

    RCircos.Set.Plot.Area();


    #   Draw chromosome ideogram
    #   _____________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    message("Draw chromosome ideogram ...\n");

    RCircos.Chromosome.Ideogram.Plot();
    title("RCircos Line Plot Demo");


    #   Plot lines
    #   _____________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    line.data <- RCircos.Line.Data;
    line.colors <- rep("blue", nrow(line.data))
    rows <- which(abs(line.data$seg.mean)>=1.5);
    line.colors[rows] <- "red";
    line.data["PlotColor"] <- line.colors;

    data.col <- 5; 
    track.num <- 1;
    direction <- "in";
    RCircos.Line.Plot(line.data, data.col, track.num, "in");


    #   Close the graphic device and clear memory
    #   ___________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    dev.off();
    message("RCircos Line Plot Demo Done!");

    #
    #   This demo draw chromosome ideogram with padding between 
    #   chromosomes, highlights, chromosome names, and tile plot. 
    #
    #   Usage:
    #
    #   library(RCircos);
    #   demo("RCircos.Tile.Plot.Demo");
    #   ______________________________________________________________________
    #   <RCircos DEMO><RCircos DEMO><RCircos DEMO><RCircos DEMO><RCircos DEMO>



    #   Load RCircos library
    #   _________________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    library(RCircos);


    #   Load human cytoband data and gene expression data
    #   _________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    data(RCircos.Tile.Data);
    data(UCSC.HG19.Human.CytoBandIdeogram);
    cyto.info <- UCSC.HG19.Human.CytoBandIdeogram;


    #   Setup RCircos core components:
    #   ________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    RCircos.Set.Core.Components(cyto.info, NULL, 10, 0);


    #   Open the graphic device (here a pdf file)
    #   ________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    pdf(file="RCircos.Tile.Plot.Demo.pdf", height=8, width=8);
    RCircos.Set.Plot.Area();


    #   Draw chromosome ideogram
    #   _________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    RCircos.Chromosome.Ideogram.Plot();
    title("RCircos Tile Plot Demo");


    #   Tile plot. Note: tile plot data have chromosome 
    #   locations only and each data file is for one track
    #   ________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    tile.data <- RCircos.Tile.Data;
    tile.colors <- rainbow(nrow(tile.data));
    tile.data["PlotColor"] <- tile.colors;

    track.num <- 9;
    RCircos.Tile.Plot(tile.data, track.num, "in");


    #   Close the graphic device and clear memory
    #   ________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    dev.off();
    message("RCircos Tile Plot Demo Done!");

    #   ______________________________________________________________________
    #   <RCircos DEMO><RCircos DEMO><RCircos DEMO><RCircos DEMO><RCircos DEMO>
    #
    #   This demo draw chromosome ideogram with padding area between 
    #   chromosomes, highlights, and chromosome names, label gene names 
    #   in the second data track and put connectors between chromosome 
    #   ideogram and gene names.
    #
    #   Usage:
    #
    #   library(RCircos);
    #   demo("RCircos.Gene.Connector.Demo");
    #   ______________________________________________________________________
    #   <RCircos DEMO><RCircos DEMO><RCircos DEMO><RCircos DEMO><RCircos DEMO>



    #   Load RCircos package and defined parameters
    #   _________________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    library(RCircos);


    #   Load gene label data and human cytoband data 
    #   _________________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    data(RCircos.Gene.Label.Data);
    data(UCSC.HG19.Human.CytoBandIdeogram);
    cyto.info <- UCSC.HG19.Human.CytoBandIdeogram;


    #   Setup RCircos core components:
    #   _________________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    RCircos.Set.Core.Components(cyto.info, NULL, 10, 5);


    #   Ready to make Circos plot. Open the graphic device (pdf file)
    #   _________________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    out.file <- "RCircos.Gene.Connector.Demo.pdf";
    pdf(file=out.file, height=8, width=8);

    RCircos.Set.Plot.Area();
    title("RCircos Gene and Connector Plot Demo");


    #   Draw chromosome ideogram
    #   _________________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    message("Draw chromosome ideogram ...\n");
    RCircos.Chromosome.Ideogram.Plot();


    #   Connectors in first track and gene names in the second track. 
    #   _________________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    message("Add Gene and connector tracks ...\n");
    data(RCircos.Gene.Label.Data);

    direction <- "in";
    track.num <- 1;
    RCircos.Gene.Connector.Plot(RCircos.Gene.Label.Data, 
                track.num, direction);

    gene.data <- RCircos.Gene.Label.Data;
    gene.colors <- rep("black", nrow(gene.data))
    gene.colors[which(gene.data$Gene=="TP53")] <- "red";
    gene.colors[which(gene.data$Gene=="BRCA2")] <- "red";
    gene.colors[which(gene.data$Gene=="RB1")] <- "red";
    gene.colors[which(gene.data$Gene=="JAK1")] <- "blue";
    gene.colors[which(gene.data$Gene=="JAK2")] <- "blue";

    gene.data["PlotColor"] <- gene.colors;

    name.col <- 4;
    track.num <- 2;
    RCircos.Gene.Name.Plot(gene.data, name.col, track.num, direction);
#

    track.num <- 1;
    direction <- "out";
    RCircos.Gene.Connector.Plot(RCircos.Gene.Label.Data, 
                track.num, direction);
    track.num <- 2;
    RCircos.Gene.Name.Plot(gene.data, name.col, track.num, direction);


    #   Close the graphic device and clear memory
    #   _________________________________________________________________
    #   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

    dev.off();
    message("R Circos Demo Done ...\n\n");

    #
    #   RCircos Zoom Plot Demo
    #
    #   This demo plot human chromosome ideogram with zoomed heatmap plot,  
    #   zoomed hitogram plot, and zoomed scatter(points) plot on outside 
    #   of chromosome ideogram.
    #
    #   Usage:
    #
    #   library(RCircos);
    #   demo("RCircos.Zoom.Plot.Demo");
    #   ______________________________________________________________________
    #   <RCircos DEMO><RCircos DEMO><RCircos DEMO><RCircos DEMO><RCircos DEMO> 


    #   Initialize the plot objects
    #   ==================================================================
    
    library(RCircos);
    data(UCSC.HG19.Human.CytoBandIdeogram);

    cyto <- UCSC.HG19.Human.CytoBandIdeogram;
    RCircos.Set.Core.Components(cyto.info=cyto, chr.exclude=NULL, 
            tracks.inside=10, tracks.outside=5);

    pdf(file="RCircos.ZoomIn.Plot.Demo.pdf", width=10, height=10);
    RCircos.Set.Plot.Area();
    RCircos.Chromosome.Ideogram.Plot();


    #    Zoom heatmap plot with defined track number
    #    ================================================================

    data(RCircos.Heatmap.Data);
    min.value <- min(as.matrix(RCircos.Heatmap.Data[,5:10]));
    max.value <- max(as.matrix(RCircos.Heatmap.Data[,5:10]));

    RCircos.Heatmap.Plot(RCircos.Heatmap.Data, data.col=5, 
            side="in", track.num=1);

    zoom.data <- RCircos.Get.Zoom.Data(RCircos.Heatmap.Data, name.col=4, 
            genomic.columns=3, target.gene="SP5", neighbor.genes=5);
    zoom.range <- RCircos.Get.Zoom.Range(zoom.data, genomic.columns=3);
    zoom.pos <- RCircos.Set.Zoom.Plot.Positions(zoom.range, total.genes=11, 
            area.length=0.25, fixed.width=TRUE, gene.width=NULL);

    RCircos.Plot.Zoomed.Heatmap(zoom.data, data.col=5, zoom.pos=zoom.pos, 
            track.num=2, outside.pos=NULL, inside.pos=NULL, 
            min.value, max.value);

    RCircos.Mark.Zoom.Area(zoom.range, track.num=2, zoom.pos=zoom.pos, 
            fill.color="red", inside.pos=NULL, outside.pos=NULL);

    RCircos.Label.Zoom.Region(zoom.data, name.col=4, zoom.pos=zoom.pos, 
            text.size=0.6, track.num=3, outside.pos=NULL, inside.pos=NULL);

    rm(zoom.data); rm(zoom.range); rm(zoom.pos);
    rm(min.value); rm(max.value);  rm(RCircos.Heatmap.Data);


    #    Zoom histogram plot with defined inside.pos and outside.pos
    #    =================================================================

    data(RCircos.Histogram.Data);
    RCircos.Histogram.Plot(RCircos.Histogram.Data, data.col=4, 
            side="in", track.num=2);

    data.rows <- which(RCircos.Histogram.Data$Chromosome=="chr4");
    zoom.data <- RCircos.Histogram.Data[data.rows[1:11], ];

    zoom.range <- RCircos.Get.Zoom.Range(zoom.data,  genomic.columns=3);
    zoom.pos <- RCircos.Set.Zoom.Plot.Positions(zoom.range, total.genes=11, 
            area.length=0.25, fixed.width=TRUE, gene.width=NULL);

    track.pos <- RCircos.Get.Track.Positions("out", 2);
    track.height <- track.pos[1] - track.pos[2];
    in.pos <- track.pos[2];
    out.pos <- in.pos + track.height*2;

    RCircos.Plot.Zoomed.Histogram(zoom.data, data.col=4, zoom.pos=zoom.pos, 
            track.num=NULL, inside.pos=in.pos, outside.pos=out.pos);

    RCircos.Mark.Zoom.Area(zoom.range, track.num=NULL, zoom.pos=zoom.pos, 
            fill.color="green", outside.pos=out.pos, inside.pos=in.pos);

    rm(zoom.data); rm(zoom.range); rm(zoom.pos);
    rm(data.rows); rm(track.pos); rm(track.height);
    rm(in.pos); rm(out.pos); rm(RCircos.Histogram.Data);


    #   Zoom point(scatter) plot  with defined inside.pos and outside.pos
    #   =================================================================

    data(RCircos.Scatter.Data);
    RCircos.Scatter.Plot(RCircos.Scatter.Data, data.col=5, track.num=3,
            side="in", by.fold=1);

    data.col <- 5;
    min.value <- min(as.matrix(RCircos.Scatter.Data[, data.col]));
    max.value <- max(as.matrix(RCircos.Scatter.Data[, data.col]));

    data.rows <- which(RCircos.Scatter.Data$Chromosome=="chr5");
    zoom.data <- RCircos.Scatter.Data[1160:1171, ];
    zoom.data["PlotColors"] <- rainbow(nrow(zoom.data));

    zoom.range <- RCircos.Get.Zoom.Range(zoom.data, genomic.columns=3);
    zoom.pos <- RCircos.Set.Zoom.Plot.Positions(zoom.range, total.genes=11, 
            area.length=0.25, fixed.width=TRUE, gene.width=NULL);

    #   Manually move zoome area a little forward to avoid overlap
    #
    zoom.pos <- zoom.pos + 1500;

    track.pos <- RCircos.Get.Track.Positions(side="out", track.num=3);
    track.height <- track.pos[1] - track.pos[2];
    in.pos <- track.pos[2];
    out.pos <- in.pos + track.height * 2;

    RCircos.Plot.Zoomed.Scatters(zoom.data, data.col=5, 
            track.num=NULL, zoom.pos=zoom.pos, 
            min.value=min.value, max.value=max.value, 
            point.type=19, with.size=TRUE, point.scale=1,
            inside.pos=in.pos, outside.pos=out.pos);

    RCircos.Mark.Zoom.Area(zoom.range, track.num=NULL, zoom.pos=zoom.pos, 
            fill.color="yellow", inside.pos=in.pos, outside.pos=out.pos);

    rm(zoom.data); rm(zoom.range); rm(zoom.pos);
    rm(data.col);  rm(min.value);  rm(max.value);
    rm(data.rows); rm(track.pos);  rm(track.height);
    rm(in.pos);    rm(out.pos);    rm(RCircos.Scatter.Data);




    #   Zoomed-in gene connectors and gene labels with defined track number
    #   ===================================================================

    data(RCircos.Heatmap.Data);
    data.rows <- which(RCircos.Heatmap.Data$Chromosome=="chr7");
    zoom.data <- RCircos.Heatmap.Data[5580:5590, 1:4];
    zoom.range <- RCircos.Get.Zoom.Range(zoom.data, genomic.columns=3);
    zoom.pos <- RCircos.Set.Zoom.Plot.Positions(zoom.range, total.genes=11, 
            area.length=0.25, fixed.width=TRUE, gene.width=NULL);
            
    RCircos.Plot.Zoomed.Gene.Connectors(zoom.data, zoom.pos=zoom.pos, 
            track.num=1, line.width=1, outside.pos=NULL, inside.pos=NULL);
        
    #   Zoomed gene connector will use three tracks so next track number
    #   must be three more
    RCircos.Label.Zoom.Region(zoom.data, name.col=4, zoom.pos=zoom.pos, 
            text.size=0.7, track.num=4, outside.pos=NULL, inside.pos=NULL);

    rm(zoom.data); rm(zoom.range); rm(zoom.pos); rm(data.rows);
    rm(RCircos.Heatmap.Data);


    #   Zoomed-in parallel line plot with defined in and out plot positions
    #   ===================================================================
    
    data(RCircos.Tile.Data);
    RCircos.Tile.Plot(RCircos.Tile.Data, track.num=4, side="in");

    data.rows <- which(RCircos.Tile.Data$Chromosome=="chr18");
    zoom.data <- RCircos.Tile.Data[data.rows, ];
    zoom.range <- RCircos.Get.Zoom.Range(zoom.data,  genomic.columns=3)
    zoom.pos <- RCircos.Set.Zoom.Plot.Positions(zoom.range,  
            total.genes=5, area.length=0.06, gene.width=NULL);

    track.pos <- RCircos.Get.Track.Positions(side="out", track.num=3);
    track.height <- track.pos[1] - track.pos[2];
    in.pos <- track.pos[2];
    out.pos <- in.pos + track.height * 2;

    RCircos.Plot.Zoomed.Parallel.Lines(zoom.data, zoom.pos=zoom.pos, 
            track.num=NULL, genomic.cols=3, line.width=3, 
            inside.pos=in.pos, outside.pos=out.pos, outline=TRUE);

    RCircos.Mark.Zoom.Area(zoom.range, track.num=NULL, zoom.pos=zoom.pos, 
            fill.color="yellow", inside.pos=in.pos, outside.pos=out.pos)

    rm(zoom.data); rm(zoom.range);   rm(zoom.pos); rm(data.rows); 
    rm(track.pos); rm(track.height); rm(in.pos);   rm(out.pos);
    rm(RCircos.Tile.Data);


    #   Zoomed-in tile plot with defined inside and outside plot positions
    #   ===================================================================

    data(RCircos.Tile.Data);
    data.rows <- which(RCircos.Tile.Data$Chromosome=="chrX");
    zoom.data <- RCircos.Tile.Data[data.rows, ];
    
    zoom.range <- RCircos.Get.Zoom.Range(zoom.data,  genomic.columns=3);
    zoom.pos <- RCircos.Set.Zoom.Plot.Positions(zoom.range, 
            total.genes=length(data.rows), area.length=0.08, 
            fixed.width=FALSE, gene.width=NULL);

    track.pos <- RCircos.Get.Track.Positions(side="out", track.num=3);
    track.height <- track.pos[1] - track.pos[2];
    in.pos <- track.pos[2];
    out.pos <- in.pos + track.height * 3;

    layers <- RCircos.Get.Plot.Layers(RCircos.Tile.Data, genomic.columns=3);
    RCircos.Plot.Zoomed.Tiles(zoom.data, zoom.pos=zoom.pos, 
            genomic.cols=3, layers=max(layers), track.num=NULL, 
            inside.pos=in.pos, outside.pos=out.pos, border.col=NULL);

    RCircos.Mark.Zoom.Area(zoom.range, track.num=NULL, zoom.pos=zoom.pos, 
            fill.color="green", inside.pos=in.pos, outside.pos=out.pos);

    rm(zoom.data); rm(zoom.range);   rm(zoom.pos); rm(data.rows); 
    rm(track.pos); rm(track.height); rm(in.pos);   rm(out.pos);
    rm(RCircos.Tile.Data);


    #   Zoomed-in chromosome ideogram tick plot with defined 
    #   inside and outside plot positions
    #   ===================================================================

    zoom.range <- c("chr15", 56828384, 71672845);
    zoom.pos <- RCircos.Set.Zoom.Plot.Positions(zoom.range, total.genes=11, 
            area.length=0.06, fixed.width=FALSE, gene.width=NULL);
    
    track.pos <- RCircos.Get.Track.Positions(side="out", track.num=3);
    track.height <- track.pos[1] - track.pos[2];
    in.pos <- track.pos[2];
    out.pos <- in.pos + track.height * 3;
    
    RCircos.Plot.Zoomed.Ideogram.Ticks(zoom.info=zoom.range, 
            zoom.pos=zoom.pos, tick.interval=2, track.num=NULL, 
            inside.pos=in.pos, outside.pos=out.pos);
    RCircos.Mark.Zoom.Area(zoom.range, track.num=NULL, zoom.pos=zoom.pos, 
            fill.color="green", inside.pos=in.pos, outside.pos=out.pos);

    rm(zoom.range); rm(zoom.pos); 
    rm(track.pos);  rm(track.height); rm(in.pos); rm(out.pos);

  
    #   Zoomed-in polygon plot with defined plot positions
    #   ===================================================================

    data(RCircos.Polygon.Data);
    data.col <- 4;
    
    rows <- seq(1, 77, by=2)
    plot.colors <- rep("red", nrow(RCircos.Polygon.Data))
    plot.colors[rows] <- "green"
    RCircos.Polygon.Data["PlotColor"] <- plot.colors
    RCircos.Polygon.Data$Data[rows] <- RCircos.Polygon.Data$Data[rows]*-1

    RCircos.Polygon.Plot(RCircos.Polygon.Data, track.num=5, 
            data.col=data.col, side="in")
 
    data.rows <- which(RCircos.Polygon.Data$Chromosome=="chr9");
    zoom.data <- RCircos.Polygon.Data[data.rows, ];

    zoom.range <- RCircos.Get.Zoom.Range(zoom.data,  genomic.columns=3);
    zoom.pos <- RCircos.Set.Zoom.Plot.Positions(zoom.range, 
            total.genes=length(data.rows), area.length=0.08, 
            fixed.width=FALSE, gene.width=NULL);

    track.pos <- RCircos.Get.Track.Positions(side="out", track.num=3)
    track.height <- track.pos[1] - track.pos[2];
    in.pos <- track.pos[2];
    out.pos <- in.pos + track.height * 3;

    min.value <- min(RCircos.Polygon.Data$Data)
    max.value <- max(RCircos.Polygon.Data$Data)
    
    RCircos.Plot.Zoomed.Polygons(zoom.data, data.col=data.col, 
            track.num=NULL, zoom.pos=zoom.pos, genomic.cols=3, 
            min.value=min.value, max.value=max.value, border.col=NULL, 
            inside.pos=in.pos, outside.pos=out.pos, outline=TRUE);

    RCircos.Mark.Zoom.Area(zoom.range, track.num=NULL, zoom.pos=zoom.pos, 
            fill.color="green", inside.pos=in.pos, outside.pos=out.pos);

    dev.off()
    message("Zoom in plot demo done!")




    #   End of RCircos.Zoom.Plot.Demo.R
    #   =============================================================

\documentclass{article}

%\VignetteIndexEntry{Using_RCircos}
%\VignetteDepends{RCircos}
%\VignetteKeyword{bioinformatics}
%\VignetteKeyword{genomics}
%\VignetteKeyword{RCircos}
%\VignettePackage{RCircos}

\usepackage{graphicx}
\usepackage{hyperref}

\begin{document}
\SweaveOpts{concordance=TRUE}

\title{Using the RCircos Package}
\author{Hongen Zhang, Ph.D.\\
Genetics Branch, Center for Cancer Research,\\
National Cancer Institute, NIH}
\date{December 19, 2021}
\maketitle

\tableofcontents


\section{Introduction}

The RCircos package provides a set of graphic functions which implement basic Circos 2D track plot \cite{Krzywinski} for visualizing similarities and differences of genome structure and positional relationships between genomic intervals. The package is implemented with R graphics package that comes with R base installation and aimed to reduce the complexity of usage and increase the flexibility in integrating into other R pipelines of genomic data processing. \\
\\
Currently, following graphic functions are provided: 

\begin{itemize}
\item
Chromosome ideogram plots for human, mouse, and rat
\item
Data plots include:
\begin{itemize}
  \item heatmap
  \item histogram 
  \item lines 
  \item scatterplot 
  \item tiles
\end{itemize}
\item
Plot items for further decoration include:
\begin{itemize}
  \item connectors
  \item links (lines and ribbons)
  \item text (gene) labels
\end{itemize}
\end{itemize}

After successful installation of RCircos, one needs to load the library to get started using it:

<<intro>>=
library(RCircos)
@ 

\section{Input Data Format}

RCircos takes the input data in the form of a data frame that could be an object returned from read.table() or generated with other pipelines in the current R session. The first three columns of the data frame, except for input to the link plot, must be genomic position information in the order of chromosome names, chromosome start, and chromosome end positions. 

<<histogramdata>>=
data(RCircos.Histogram.Data)
head(RCircos.Histogram.Data)
@ 

For gene labels and heatmap plots, the gene/probe names must be provided in the fourth column. For other plots, this column could be optional. 

<<heatmapdata>>=
data(RCircos.Heatmap.Data)
head(RCircos.Heatmap.Data)
@ 

Different from other plot data, the input data for link line plot has only paired genomic position information for each row in the order of chromosome name A, chromStart A, chromEnd A, chromosome name B, chromStart B, and chromEnd B.

<<linkdata>>=
data(RCircos.Link.Data)
head(RCircos.Link.Data)
@

Note: RCircos will convert the input data to RCircos plot data but it does not provide functionality for general data processing. If the data frame does not have genomic position information, you have to add the information to the data frame before passing it to RCircos functions. Sample datasets are included in the package for demo purpose and they could be easily explored with data() method. \\
\\
Starting  from version 1.1.2, user can append to input data a column of plot color names with header of "PlotColor" to control the colors for each data point except of heatmap plot.\\


\section{Plot Track Layout}

RCircos follows the same algorithm of Circos plot and arranges data plots in tracks. A track could be placed either inside or outside of chromosome ideogram and the detailed position for a track could be easily manipulated by changing of the track width and track numbers. \\
\\
The figure below shows a human chromosome ideogram plus three empty tracks arranged in both inside and outside of chromosome ideogram.

\includegraphics[width=\textwidth]{RCircosLayoutDemo.png}

\section{Getting Started: Initialize RCircos core components first}

\subsection{Initialize RCircos core components}

The first step of making RCircos plot is to initialize RCircos core components. To setup RCircos core components, user needs load the chromosome ideogram data into current R session. The RCircos package have three build-in datasets for human, mouse, and rat chromosome ideograms which can be loaded with data() command. Ideogram data in text files with same format can also be loaded with read.table() function in R.

<<>>=
data(UCSC.HG19.Human.CytoBandIdeogram);
head(UCSC.HG19.Human.CytoBandIdeogram);

data(UCSC.Mouse.GRCm38.CytoBandIdeogram);
head(UCSC.Mouse.GRCm38.CytoBandIdeogram);

data(UCSC.Baylor.3.4.Rat.cytoBandIdeogram);
head(UCSC.Baylor.3.4.Rat.cytoBandIdeogram);
@

After the chromosome ideogram data is loaded, RCircos core components can be initialized with function of RCircos.Set.Core.Components(). This function needs four arguments:

\begin{description}
\item[cytoinfo]
the chromosome ideogram data loaded
\item[chr.exclude]
chromosomes should be excluded from ideogram, e.g., chr.exclude <- c("chrX", "chrY");. If it is set to NULL, no chromosome will be excluded. 
\item[tracks.inside]
how many tracks will be plotted inside chromosome ideogram
\item[tracks.outside]
how many data tracks will be plotted outside chromosome ideogram
\end{description}

Following code initialize RCircos core components with all human chromosome ideogram and 10 data track space inside of chromosome ideogram.

<<>>=
chr.exclude <- NULL;
cyto.info <- UCSC.HG19.Human.CytoBandIdeogram;
tracks.inside <- 10;
tracks.outside <- 0;
RCircos.Set.Core.Components(cyto.info, chr.exclude, 
       tracks.inside, tracks.outside);
@


RCircos use three core components to perform data transformation and data plot: 

\begin{description}
  \item[RCircos cytoband data]
RCircos cytoband data is derived from the input chromosome ideogram data. Except of the chromosome name, start and end positions, band name and stain intensity for each band, chromosome highlight colors, band colors, band length in base pairs and chromosome units as well as the relative location on the circular layout are also included. These data are used to calculate the plot location of each genomic data.
  \item[RCircos plot positions]
RCircos plot positions are x and y coordinates for a circular line of radius 1.0 and the total number of points for the circular line are decided by the total number of chromosome units. One chromosome units is a plot point which covers a defined number of base pairs and total units for chromosome ideogram include units of each band plus chromosome padding area, both of them are defined in the list of plot parameters.
  \item[RCircos plot parameters] 
RCircos plot parameters are only one core components open to users. With the get and reset methods, users can modify the parameters for updating other two core components. Following are RCircos plot parameters and their default values:
\begin{description}
\item[base.per.unit]
Number of base pairs a chromosome unit (a plot point) will cover, default: 30000
\item[chrom.paddings]
Width of padding between two chromosomes in chromosome unit, default: 300
(Note: chrom.paddings is binded to base.per.unit. It will be automatically updated if the base.per.unit is changed, unless be set to zero).
\item[tracks.inside]
Total number of data tracks inside of chromosome ideogram. Read-only.
\item[tracks.outside]
Total number of data tracks outside of chromosome ideogram. Read-only.

\medskip 

\item[radiu.len] 
The radius of a circular line which serves as baseline for
calculation of plot items, default: 1
\item[plot.radius]
Radius of plot area,default: 1.5
\item[chr.ideo.pos]
Radius of chromosome ideogram position, default: 1.1
\item[highlight.pos]
Radius of chromosome ideogram highlights, default: 1.25
\item[chr.name.po]
Radius of chromosome name position, default: 1.4

\item[track.in.start]
Radius of start position of the first track inside of chromosome idogram, default: 1.05
\item[track.out.start]
Radius of start position of the first track outside of chromosome idogram, default: 1.6

\medskip  

\item[chrom.width]
Width of chromosomes of the ideogram, default: 0.1
\item[track.padding]
Width of padding between two plot tracks, default: 0.02
\item[track.height]
Height of data plot track, default: 0.1
 (Note: Parameters above are all relative to the radius.len and will be updated automatically if new radiu.len is reset.

\medskip  
    
\item[hist.width]
Width of histogram column in chromosome unit, default: 100
\item[heatmap.width]
Width of heatmap cells in chromosome unit, default: 100  
\item[text.size]
Character size (same as cex in R graphics package) for text plot, default: 0.4
\item[char.width]
Width of a charater on RCircos plot, default 500 (chromosome unit)
\item[highlight.width]
Line type (same as lty in R graphics package) for chromosome highlight, default: 2
\item[point.size]
Point size (same as cex in R graphics package) for scatter plot, default: 1
\item[Bezier.point]
Total number of points for a link(Bezier) line default: 1000
\item[max.layers]
Maximum number of layers for tile plot, default: 5
\item[sub.tracks]
Number of sub tracks in a data track, default: 5
\smallskip

\item[text.color]
Color for text plot, default: black
\item[hist.color]
Color for histgram plot, default: red
\item[line.color]
Color for line plot, default: black
\item[scatter.color]
Color for scatter plot, default: black
\item[tile.color]
Color for tile plot, default: black
\item[track.background]
Color of track background, default: wheat
\item[grid.line.color]
Color for track grids, default: gray
\smallskip

\item[heatmap.color]
Color scales for heatmap plot, default: BlueWhiteRed
\item[point.type]
Point type (same as pch in R graphics package) for scatter plot, default: "."
\end{description}
\end{description}

The core components are stored in RCircos session and each component is supplied with one Get method for advanced usage. In addition, simply call the function RCircos.List.Parameters() will list all current plot parameters.

<<>>=
rcircos.params <- RCircos.Get.Plot.Parameters();
rcircos.cyto <- RCircos.Get.Plot.Ideogram();
rcircos.position <- RCircos.Get.Plot.Positions();
@

<<>>=
RCircos.List.Plot.Parameters()
@


\subsection{Modifying RCircos core components}

Among the three RCircos core components, RCircos cytoband data and RCircos plot positions are calculated based on plot parameter setting. Users can modify RCircos core components by changing plot parameters. Once the plot parameter(s) is changed, call and pass the new parameters to the function of RCircos.Reset.Plot.Parameters(), other two components will be checked for update.

<<>>=
rcircos.params <- RCircos.Get.Plot.Parameters();
rcircos.params$base.per.unit <- 3000;
RCircos.Reset.Plot.Parameters(rcircos.params);
@

<<>>=
RCircos.List.Plot.Parameters();
@


\section{Making a Plot with RCircos}

Plotting with RCircos is a stepwise process.  First, an initialization step is needed.  Then, tracks and other aspects of the plot are added sequentially. The result is available after the plot has been entirely constructed.  The next subsections walk through the process in detail.

\subsection{Initialize Graphic Device}

RCircos provides a set of graphic plot functions but does not handle graphic devices. To make RCircos plots, a graphic device has to be opened first. Currently, RCircos works with files supported by R graphics package such as tiff, png, pdf images as well as GUI windows.  For example, to make a pdf file with RCircos plot image:

<<eval=FALSE>>=
out.file <- "RCircosDemoHumanGenome.pdf";
pdf(file=out.file, height=8, width=8, compress=TRUE);
RCircos.Set.Plot.Area();
@

Note: RCircos.Set.Plot.Area() will setup plot area base on total number of tracks inside and outside of chromosome ideogram. User can also setup plot area by summit the R plot commands for user defined plot area, for example:\\

<<eval=FALSE>>=
par(mai=c(0.25, 0.25, 0.25, 0.25));
plot.new();
plot.window(c(-2.5,2.5), c(-2.5, 2.5));
@

Note: After everything is done, the graphic device needs to be closed with dev.off().


\subsection{Plot Chromosome Ideogram}

For RCircos plot, a common first step is to draw chromosome ideograms and label chromosomes with names and highlights. After the RCircos core components were initialized and graphic device was open, simply call the function of \\RCircos.Chromosome.Ideogram.Plot() will add the chromosome ideogram to the current plot. 

<<eval=FALSE>>=
RCircos.Chromosome.Ideogram.Plot();
@


\subsection{Gene Labels and connectors on RCircos Plot}

Due to the resolution issues, only limited number of gene names can be labeled. For best visualization, cex should be no less than 0.4 when draw gene labels. When cex is set to 0.4, width of character will be 5000 chromosome units when each unit covers 3000 base pairs. If the gene name list supplied is too long, it will be truncated to fit the chromosome length. Also the long gene name will span more than one track so one or more tracks may be needed to skip for next track.\\
\\
Connectors are used to mark a genomic position with their names or variant status. Currently, RCircos only provide connector plot between genes and their genomic positions. The following code draw connectors on the first track inside chromosome ideogram and plot gene names on the next track.

<<eval=FALSE>>=
data(RCircos.Gene.Label.Data);

name.col <- 4;
side <- "in";

track.num <- 1;
RCircos.Gene.Connector.Plot(RCircos.Gene.Label.Data,
        track.num, side);

track.num <- 2;
RCircos.Gene.Name.Plot(RCircos.Gene.Label.Data, 
        name.col,track.num, side);
@


\subsection{Heatmap, Histogram, Line, Scatter, and Tile Plot}

Heatmap, histogram, line, scatter, and tile plot with RCircos require that the first three columns of input data are genomic position information in the order of chromosome name, start, and end position. RCircos provides one function for each type of plots and each function will draw one data track. User can simply call each function with appropriate arguments such as plot location (which track and which side of chromosome ideogram). No more data processing needed.\\
\\
The code below will draw data tracks of heatmap, scatter, line, histogram, and tile plots.

<<eval=FALSE>>=
data(RCircos.Heatmap.Data);
data.col <- 6;
track.num <- 5;	
side <- "in";
RCircos.Heatmap.Plot(RCircos.Heatmap.Data, data.col, 
    track.num, side);
@

<<eval=FALSE>>=
data(RCircos.Scatter.Data);
data.col <- 5;
track.num <- 6; 
side <- "in";
by.fold <- 1;
RCircos.Scatter.Plot(RCircos.Scatter.Data, data.col, 
    track.num, side, by.fold);
@

<<eval=FALSE>>=
data(RCircos.Line.Data);
data.col <- 5;
track.num <- 7;
side <- "in";
RCircos.Line.Plot(RCircos.Line.Data, data.col, 
    track.num, side);
@

<<eval=FALSE>>=	
data(RCircos.Histogram.Data);
data.col <- 4;
track.num <- 8; 
side <- "in";
RCircos.Histogram.Plot(RCircos.Histogram.Data, 
    data.col, track.num, side);
@

<<eval=FALSE>>=
data(RCircos.Tile.Data);
track.num <- 9;
side <- "in";
RCircos.Tile.Plot(RCircos.Tile.Data, track.num, side);
@


\subsection{Links: A Special Plot}

Links presents relationship of two genomic positions and it is always the last track inside chromosome ideogram. Different from other data plots, input data for links plot is a data frame with paired genomic positions in the order of chromosome, start, and end position for each one genomic position. RCircos supports two types of link plot: lines and ribbons. Link lines are used for presenting relationship of two small genomic regions and ribbons are plotted for bigger genomic regions. Colors for links between chromosomes or same chromosomes could be modified by defining by.chromosome=TRUE (or FALSE).\\
\\
Following code draw link lines and ribbons in the center of plot area.

<<eval=FALSE>>=	
data(RCircos.Link.Data);
track.num <- 11;
RCircos.Link.Plot(RCircos.Link.Data, track.num, TRUE);

data(RCircos.Ribbon.Data);
RCircos.Ribbon.Plot(ribbon.data=RCircos.Ribbon.Data, 
    track.num=11, by.chromosome=FALSE, twist=FALSE);

dev.off();
@

Run all code above will generate an image like below.\\
\\
\includegraphics[width=\textwidth]{RCircosDemoHuman.png}


\section{More Information}

Several demo samples are included in the package. Simply run following demos to see how the RCircos works for simple and complex RCircos plot.

<<eval=FALSE>>=
library(RCircos);
demo("RCircos.Demo.Human");
demo("RCircos.Demo.Mouse.And.Rat");
@

\section{sessionInfo}
<<sessionInfo>>=
sessionInfo()
@ 

\begin{thebibliography}{1}
\bibitem{Krzywinski} Krzywinski, Martin I and Schein, Jacqueline E and Birol, Inanc and Connors, Joseph and Gascoyne, Randy and Horsman, Doug and Jones, Steven J and Marra, Marco A.  Circos: An information aesthetic for comparative genomics. \textit{Genome Research}, 2009.
\end{thebibliography}

\end{document}
